Index: cpukit/rtems/src/partmp.c
===================================================================
--- cpukit/rtems/src/partmp.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/partmp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,74 +1,27 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
- *
- * @ingroup RTEMSImplClassicPartitionMP
- *
- * @brief This source file contains the implementation to support the Partition
- *   Manager in multiprocessing (MP) configurations.
- */
-
 /*
- *  COPYRIGHT (c) 1989-2008.
+ *  Multiprocessing Support for the Partition Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
  *  On-Line Applications Research Corporation (OAR).
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/partimpl.h>
-#include <rtems/rtems/statusimpl.h>
-#include <rtems/score/statesimpl.h>
-#include <rtems/score/threadimpl.h>
-#include <rtems/score/threadqimpl.h>
-#include <rtems/sysinit.h>
-
-RTEMS_STATIC_ASSERT(
-  sizeof(Partition_MP_Packet) <= MP_PACKET_MINIMUM_PACKET_SIZE,
-  Partition_MP_Packet
-);
-
-static Partition_MP_Packet *_Partition_MP_Get_packet( void )
-{
-  return (Partition_MP_Packet *) _MPCI_Get_packet();
-}
-
-static void _Partition_MP_Initialize_packet(
-  Partition_MP_Packet            *the_packet,
-  Objects_Id                      id,
-  Partition_MP_Remote_operations  operation
-)
-{
-  the_packet->Prefix.the_class  = MP_PACKET_PARTITION;
-  the_packet->Prefix.length     = sizeof( *the_packet );
-  the_packet->Prefix.to_convert = sizeof( *the_packet );
-  the_packet->Prefix.id         = id;
-  the_packet->operation         = operation;
-}
-
-/*
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/mpci.h>
+#include <rtems/mppkt.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/part.h>
+#include <rtems/thread.h>
+
+/*PAGE
+ *
  *  _Partition_MP_Send_process_packet
  *
@@ -78,10 +31,10 @@
   Partition_MP_Remote_operations  operation,
   Objects_Id                      partition_id,
-  rtems_name                      name,
+  Objects_Name                    name,
   Objects_Id                      proxy_id
 )
 {
   Partition_MP_Packet *the_packet;
-  uint32_t             node;
+  unsigned32           node;
 
   switch ( operation ) {
@@ -91,11 +44,15 @@
     case PARTITION_MP_EXTRACT_PROXY:
 
-      the_packet = _Partition_MP_Get_packet();
-      _Partition_MP_Initialize_packet( the_packet, partition_id, operation );
-      the_packet->name     = name;
-      the_packet->proxy_id = proxy_id;
+      the_packet                    = _Partition_MP_Get_packet();
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_PARTITION;
+      the_packet->Prefix.length     = sizeof ( Partition_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( Partition_MP_Packet );
+      the_packet->operation         = operation;
+      the_packet->Prefix.id         = partition_id;
+      the_packet->name              = name;
+      the_packet->proxy_id          = proxy_id;
 
       if ( operation == PARTITION_MP_EXTRACT_PROXY )
-         node = _Objects_Get_node( partition_id );
+         node = rtems_get_node( partition_id );
       else
          node = MPCI_ALL_NODES;
@@ -112,21 +69,17 @@
 }
 
-/*
+/*PAGE
+ *
  *  _Partition_MP_Send_request_packet
  *
  */
 
-static rtems_status_code _Partition_MP_Send_request_packet (
+rtems_status_code _Partition_MP_Send_request_packet (
+  Partition_MP_Remote_operations  operation,
   Objects_Id                      partition_id,
-  void                           *buffer,
-  Partition_MP_Remote_operations  operation
+  void                           *buffer
 )
 {
   Partition_MP_Packet *the_packet;
-  Status_Control       status;
-
-  if ( !_Partition_MP_Is_remote( partition_id ) ) {
-    return RTEMS_INVALID_ID;
-  }
 
   switch ( operation ) {
@@ -135,14 +88,20 @@
     case PARTITION_MP_RETURN_BUFFER_REQUEST:
 
-      the_packet = _Partition_MP_Get_packet();
-      _Partition_MP_Initialize_packet( the_packet, partition_id, operation );
-      the_packet->buffer = buffer;
-
-      status = _MPCI_Send_request_packet(
-        _Objects_Get_node( partition_id ),
-        &the_packet->Prefix,
-        STATES_READY /* Not used */
-      );
-      return _Status_Get( status );
+      the_packet                    = _Partition_MP_Get_packet();
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_PARTITION;
+      the_packet->Prefix.length     = sizeof ( Partition_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( Partition_MP_Packet );
+      the_packet->operation         = operation;
+      the_packet->Prefix.id         = partition_id;
+      the_packet->buffer            = buffer;
+
+      return
+        _MPCI_Send_request_packet(
+          rtems_get_node( partition_id ),
+          &the_packet->Prefix,
+          STATES_READY      /* Not used */
+        );
+
+      break;
 
     case PARTITION_MP_ANNOUNCE_CREATE:
@@ -161,35 +120,11 @@
 }
 
-rtems_status_code _Partition_MP_Get_buffer(
-  rtems_id   id,
-  void     **buffer
-)
-{
-  _Thread_Get_executing()->Wait.return_argument = buffer;
-  return _Partition_MP_Send_request_packet(
-    id,
-    buffer,
-    PARTITION_MP_GET_BUFFER_REQUEST
-  );
-}
-
-rtems_status_code _Partition_MP_Return_buffer(
-  rtems_id  id,
-  void     *buffer
-)
-{
-  return _Partition_MP_Send_request_packet(
-    id,
-    buffer,
-    PARTITION_MP_RETURN_BUFFER_REQUEST
-  );
-}
-
-/*
+/*PAGE
+ *
  *  _Partition_MP_Send_response_packet
  *
  */
 
-static void _Partition_MP_Send_response_packet (
+void _Partition_MP_Send_response_packet (
   Partition_MP_Remote_operations  operation,
   Objects_Id                      partition_id,
@@ -214,5 +149,5 @@
 
       _MPCI_Send_response_packet(
-        _Objects_Get_node( the_packet->Prefix.source_tid ),
+        rtems_get_node( the_packet->Prefix.source_tid ),
         &the_packet->Prefix
       );
@@ -229,5 +164,12 @@
 }
 
-static void _Partition_MP_Process_packet(
+/*PAGE
+ *
+ *
+ *  _Partition_MP_Process_packet
+ *
+ */
+
+void _Partition_MP_Process_packet (
   rtems_packet_prefix  *the_packet_prefix
 )
@@ -235,4 +177,5 @@
   Partition_MP_Packet *the_packet;
   Thread_Control      *the_thread;
+  boolean              ignored;
 
   the_packet = (Partition_MP_Packet *) the_packet_prefix;
@@ -242,10 +185,10 @@
     case PARTITION_MP_ANNOUNCE_CREATE:
 
-      _Objects_MP_Allocate_and_open(
-        &_Partition_Information,
-        the_packet->name,
-        the_packet->Prefix.id,
-        true
-      );
+      ignored = _Objects_MP_Open(
+                  &_Partition_Information,
+                  the_packet->name,
+                  the_packet->Prefix.id,
+                  TRUE
+                );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -263,7 +206,6 @@
       the_thread = _Thread_MP_Find_proxy( the_packet->proxy_id );
 
-      if ( the_thread != NULL ) {
-        _Thread_queue_Extract( the_thread );
-      }
+      if ( ! _Thread_Is_null( the_thread ) )
+         _Thread_queue_Extract( the_thread->Wait.queue, the_thread );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -317,5 +259,6 @@
 }
 
-/*
+/*PAGE
+ *
  *  _Partition_MP_Send_object_was_deleted
  *
@@ -325,5 +268,6 @@
  */
 
-/*
+/*PAGE
+ *
  *  _Partition_MP_Send_extract_proxy
  *
@@ -331,12 +275,11 @@
 
 void _Partition_MP_Send_extract_proxy (
-  Thread_Control *the_thread,
-  Objects_Id      id
+  Thread_Control *the_thread
 )
 {
   _Partition_MP_Send_process_packet(
     PARTITION_MP_EXTRACT_PROXY,
-    id,
-    (rtems_name) 0,
+    the_thread->Wait.id,
+    (Objects_Name) 0,
     the_thread->Object.id
   );
@@ -344,15 +287,14 @@
 }
 
-static void _Partition_MP_Initialize( void )
-{
-  _MPCI_Register_packet_processor(
-    MP_PACKET_PARTITION,
-    _Partition_MP_Process_packet
-  );
-}
-
-RTEMS_SYSINIT_ITEM(
-  _Partition_MP_Initialize,
-  RTEMS_SYSINIT_CLASSIC_PARTITION_MP,
-  RTEMS_SYSINIT_ORDER_MIDDLE
-);
+/*PAGE
+ *
+ *  _Partition_MP_Get_packet
+ *
+ */
+
+Partition_MP_Packet *_Partition_MP_Get_packet ( void )
+{
+  return ( (Partition_MP_Packet *) _MPCI_Get_packet() );
+}
+
+/* end of file */
Index: cpukit/rtems/src/ratemon.c
===================================================================
--- cpukit/rtems/src/ratemon.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/ratemon.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,48 +1,401 @@
-/**
- * @file
- *
- * @ingroup RTEMSImplClassicRateMonotonic
- *
- * @brief This source file contains a definition of the
- *   ::_Rate_monotonic_Information with zero objects.
- */
-
 /*
- * SPDX-License-Identifier: BSD-2-Clause
- *
- * Copyright (C) 2018 embedded brains GmbH & Co. KG
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/ratemondata.h>
-
-OBJECTS_INFORMATION_DEFINE_ZERO(
-  _Rate_monotonic,
-  OBJECTS_CLASSIC_API,
-  OBJECTS_RTEMS_PERIODS,
-  OBJECTS_NO_STRING_NAME
-);
+ *  Rate Monotonic Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/isr.h>
+#include <rtems/object.h>
+#include <rtems/ratemon.h>
+#include <rtems/thread.h>
+
+/*PAGE
+ *
+ *  _Rate_monotonic_Manager_initialization
+ *
+ *  This routine initializes all Rate Monotonic Manager related
+ *  data structures.
+ *
+ *  Input parameters:
+ *    maximum_periods - number of periods timers to initialize
+ *
+ *  Output parameters:  NONE
+ *
+ *  NOTE: The Rate Monotonic Manager is built on top of the Watchdog
+ *        Handler.
+ */
+
+void _Rate_monotonic_Manager_initialization(
+  unsigned32 maximum_periods
+)
+{
+  _Objects_Initialize_information(
+     &_Rate_monotonic_Information,
+     FALSE,
+     maximum_periods,
+     sizeof( Rate_monotonic_Control )
+  );
+}
+
+/*PAGE
+ *
+ *  rtems_rate_monotonic_create
+ *
+ *  This directive creates a rate monotonic timer and performs
+ *  some initialization.
+ *
+ *  Input parameters:
+ *    name - name of period
+ *    id   - pointer to rate monotonic id
+ *
+ *  Output parameters:
+ *    id                - rate monotonic id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_rate_monotonic_create(
+  Objects_Name  name,
+  Objects_Id   *id
+)
+{
+  Rate_monotonic_Control *the_period;
+
+  if ( !_Objects_Is_name_valid( name ) )
+    return( RTEMS_INVALID_NAME );
+
+  _Thread_Disable_dispatch();            /* to prevent deletion */
+
+  the_period = _Rate_monotonic_Allocate();
+
+  if ( !the_period ) {
+    _Thread_Enable_dispatch();
+    return( RTEMS_TOO_MANY );
+  }
+
+  the_period->owner = _Thread_Executing;
+  the_period->state = RATE_MONOTONIC_INACTIVE;
+
+  _Objects_Open( &_Rate_monotonic_Information, &the_period->Object, name );
+
+  *id = the_period->Object.id;
+  _Thread_Enable_dispatch();
+  return( RTEMS_SUCCESSFUL );
+}
+
+/*PAGE
+ *
+ *  rtems_rate_monotonic_ident
+ *
+ *  This directive returns the system ID associated with
+ *  the rate monotonic period name.
+ *
+ *  Input parameters:
+ *    name - user defined period name
+ *    id   - pointer to period id
+ *
+ *  Output parameters:
+ *    *id               - region id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_rate_monotonic_ident(
+  Objects_Name  name,
+  Objects_Id   *id
+)
+{
+  return _Objects_Name_to_id(
+    &_Rate_monotonic_Information,
+    name,
+    RTEMS_SEARCH_LOCAL_NODE,
+    id
+  );
+}
+
+/*PAGE
+ *
+ *  rtems_rate_monotonic_cancel
+ *
+ *  This directive allows a thread to cancel a rate monotonic timer.
+ *
+ *  Input parameters:
+ *    id - rate monotonic id
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful and caller is not the owning thread
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_rate_monotonic_cancel(
+  Objects_Id id
+)
+{
+  Rate_monotonic_Control *the_period;
+  Objects_Locations              location;
+
+  the_period = _Rate_monotonic_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:            /* should never return this */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+      if ( !_Thread_Is_executing( the_period->owner ) ) {
+        _Thread_Enable_dispatch();
+        return( RTEMS_NOT_OWNER_OF_RESOURCE );
+      }
+      (void) _Watchdog_Remove( &the_period->Timer );
+      the_period->state = RATE_MONOTONIC_INACTIVE;
+      _Thread_Enable_dispatch();
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_rate_monotonic_delete
+ *
+ *  This directive allows a thread to delete a rate monotonic timer.
+ *
+ *  Input parameters:
+ *    id - rate monotonic id
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_rate_monotonic_delete(
+  Objects_Id id
+)
+{
+  Rate_monotonic_Control *the_period;
+  Objects_Locations              location;
+
+  the_period = _Rate_monotonic_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:            /* should never return this */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+      _Objects_Close( &_Rate_monotonic_Information, &the_period->Object );
+      (void) _Watchdog_Remove( &the_period->Timer );
+      the_period->state = RATE_MONOTONIC_INACTIVE;
+      _Rate_monotonic_Free( the_period );
+      _Thread_Enable_dispatch();
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_rate_monotonic_period
+ *
+ *  This directive allows a thread to manipulate a rate monotonic timer.
+ *
+ *  Input parameters:
+ *    id     - rate monotonic id
+ *    length - length of period (in ticks)
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_rate_monotonic_period(
+  Objects_Id        id,
+  rtems_interval length
+)
+{
+  Rate_monotonic_Control *the_period;
+  Objects_Locations       location;
+  rtems_status_code            return_value;
+
+  the_period = _Rate_monotonic_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:            /* should never return this */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+      if ( !_Thread_Is_executing( the_period->owner ) ) {
+        _Thread_Enable_dispatch();
+        return( RTEMS_NOT_OWNER_OF_RESOURCE );
+      }
+
+      if ( length == RTEMS_PERIOD_STATUS ) {
+        switch ( the_period->state ) {
+          case RATE_MONOTONIC_INACTIVE:
+            return_value = RTEMS_NOT_DEFINED;
+            break;
+          case RATE_MONOTONIC_ACTIVE:
+            return_value = RTEMS_SUCCESSFUL;
+            break;
+          case RATE_MONOTONIC_EXPIRED:
+            return_value = RTEMS_TIMEOUT;
+            break;
+          default:              /* unreached -- only to remove warnings */
+            return_value = RTEMS_INTERNAL_ERROR;
+            break;
+        }
+        _Thread_Enable_dispatch();
+        return( return_value );
+      }
+
+      switch ( the_period->state ) {
+        case RATE_MONOTONIC_INACTIVE:
+          the_period->state = RATE_MONOTONIC_ACTIVE;
+          _Watchdog_Initialize(
+            &the_period->Timer,
+            _Rate_monotonic_Timeout,
+            id,
+            NULL
+          );
+          _Watchdog_Insert_ticks(
+                     &the_period->Timer, length, WATCHDOG_ACTIVATE_NOW );
+          _Thread_Enable_dispatch();
+          return( RTEMS_SUCCESSFUL );
+
+        case RATE_MONOTONIC_ACTIVE:
+/* following is and could be a critical section problem */
+          _Thread_Executing->Wait.id  = the_period->Object.id;
+          if ( _Rate_monotonic_Set_state( the_period ) ) {
+            _Thread_Enable_dispatch();
+            return( RTEMS_SUCCESSFUL );
+          }
+         /* has expired -- fall into next case */
+        case RATE_MONOTONIC_EXPIRED:
+          the_period->state = RATE_MONOTONIC_ACTIVE;
+          _Watchdog_Insert_ticks(
+                     &the_period->Timer, length, WATCHDOG_ACTIVATE_NOW );
+          _Thread_Enable_dispatch();
+          return( RTEMS_TIMEOUT );
+      }
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ * _Rate_monotonic_Set_state
+ *
+ * This kernel routine sets the STATES_WAITING_FOR_PERIOD state in
+ * the running thread's tcb if the specified period has not expired.
+ * The ready chain is adjusted if necessary.
+ *
+ * Input parameters:
+ *   the_period - pointer to period control block
+ *
+ * Output parameters:
+ *   TRUE  - if blocked successfully for period
+ *   FALSE - if period has expired
+ *
+ *  INTERRUPT LATENCY:
+ *    delete node
+ *    priority map
+ *    select heir
+ */
+
+boolean _Rate_monotonic_Set_state(
+Rate_monotonic_Control *the_period
+)
+{
+  Thread_Control *executing;
+  Chain_Control  *ready;
+  ISR_Level              level;
+  States_Control         old_state;
+
+  executing = _Thread_Executing;
+  ready     = executing->ready;
+  _ISR_Disable( level );
+
+  old_state = executing->current_state;
+
+  if ( _Rate_monotonic_Is_expired( the_period ) ) {
+    _ISR_Enable( level );
+    return( FALSE );
+  }
+
+  executing->current_state =
+             _States_Set( STATES_WAITING_FOR_PERIOD, old_state );
+
+  if ( _States_Is_ready( old_state ) ) {
+    if ( _Chain_Has_only_one_node( ready ) ) {
+      _Chain_Initialize_empty( ready );
+      _Priority_Remove_from_bit_map( &executing->Priority_map );
+      _ISR_Flash( level );
+    } else {
+      _Chain_Extract_unprotected( &executing->Object.Node );
+      _ISR_Flash( level );
+    }
+
+    if ( _Thread_Is_heir( executing ) )
+      _Thread_Calculate_heir();
+
+    _Context_Switch_necessary = TRUE;
+  }
+
+  _ISR_Enable( level );
+  return( TRUE );
+}
+
+/*PAGE
+ *
+ *  _Rate_monotonic_Timeout
+ *
+ *  This routine processes a period ending.  If the owning thread
+ *  is waiting for the period, that thread is unblocked and the
+ *  period reinitiated.  Otherwise, the period is expired.
+ *  This routine is called by the watchdog handler.
+ *
+ *  Input parameters:
+ *    id - period id
+ *
+ *  Output parameters: NONE
+ */
+
+void _Rate_monotonic_Timeout(
+  Objects_Id  id,
+  void       *ignored
+)
+{
+  Rate_monotonic_Control *the_period;
+  Objects_Locations              location;
+  Thread_Control         *the_thread;
+
+  the_period = _Rate_monotonic_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+    case OBJECTS_REMOTE:  /* impossible */
+      break;
+    case OBJECTS_LOCAL:
+      the_thread = the_period->owner;
+      if ( _States_Is_waiting_for_period( the_thread->current_state ) &&
+            the_thread->Wait.id == the_period->Object.id ) {
+        _Thread_Unblock( the_thread );
+        _Watchdog_Reset( &the_period->Timer );
+      }
+      else
+        the_period->state = RATE_MONOTONIC_EXPIRED;
+      _Thread_Unnest_dispatch();
+      break;
+  }
+}
+
